EvaluateScript("Colours.js");
EvaluateScript("Mouse Library.js");

var mouse = new _mouse();








var a = [0, 1, 2, 3, 4, 5, 6, 7, 8];
var b = a.splice(5, 1);
//Abort(a)









//========================================================================================================================
//                                                     Draw Text
//========================================================================================================================
var font = LoadFont("Font.rfn");
function drawText(x, y, text, color)
{
  var color = color || white
  font.setColorMask(black);
  font.drawText(x + 1, y + 1, text);
  font.setColorMask(color);
  font.drawText(x, y, text);
}

var xIcon = LoadImage("X Icon.png");
var mapIcon = LoadImage("Mapp Icon.png");
var directoryIcon = LoadImage("Directory Icon.png");
var saveIcon = LoadImage("Save Icon.png");
var layerUpIcon = LoadImage("Layer Up.png");
var layerDownIcon = LoadImage("Layer Down.png");
var deleteIcon = LoadImage("Delete.png");
var layerVisible = LoadImage("Layer Visible.png");
var layerInvisible = LoadImage("Layer Invisible.png");
var scrollUp = LoadImage("Scroll Up.png");
var scrollDown = LoadImage("Scroll Down.png");
var scrollLeft = LoadImage("Scroll Left.png");
var scrollRight = LoadImage("Scroll Right.png");
var background = LoadSurface("Background.png");
var tile32 = LoadImage("32 Tile.png");
var yesIcon = createWindow(40, 16, true).createSurface();
font.setColorMask(black);
yesIcon.drawText(font, 11, 7, "Yes");
font.setColorMask(white);
yesIcon.drawText(font, 10, 6, "Yes");
yesIcon = yesIcon.createImage();
var noIcon = createWindow(40, 16, true).createSurface();
font.setColorMask(black);
noIcon.drawText(font, 15, 7, "No");
font.setColorMask(white);
noIcon.drawText(font, 15, 6, "No");
noIcon = noIcon.createImage();

//========================================================================================================================
//                                                     Get Super Parent
//========================================================================================================================
function getParent(obj)
{
  while (obj.parent)
  {
    obj = obj.parent;
  }
  return obj
}

//========================================================================================================================
//                                                     Create Window
//========================================================================================================================

function createWindow(w, h, fill)
{
  var window = CreateSurface(w + 4, h + 4, CreateColor(0, 0, 0, 0));

  if (fill)
  {
    var testX = (window.width - 4) / background.width;
    var testY = (window.height - 4) / background.height;
  
    for (var x = 0; x < testX; x++)
    {
      for (var y = 0; y < testY; y++)
      {
        window.blitSurface(background, 2 + (x * background.width), 2 + (y * background.height));
      }
    }
  }
  
  window.line(w + 3, 0, w + 3, h + 3, black);
  window.line(0, h + 3, w + 3, h + 3, black);
  
  window.line(1, 1, w + 2, 1, white);
  window.line(1, 1, 1, h + 1, white);
  
  window.line(1, h + 2, w + 2, h + 2, windowGrey2);
  window.line(w + 2, 2, w + 2, h + 2, windowGrey2);
  
  window.line(0, 0, w + 2, 0, windowGrey1);
  window.line(0, 0, 0, h + 2, windowGrey1);
  
  return window.createImage();
}

// NOTE: For multi support save both the image and surface
//========================================================================================================================
//                                                     Tile Object
//========================================================================================================================
function tileObject(image, id, column, row) // A induvidual tile object
{
  this.surface = image; // Stores a surface copy of the tile
  this.image = image.createImage(); // Stores a image copy of the tile
  this.id = id; // Stores the ID for the tile in a 1 dimensional respect
  this.column = column; // Stores the tiles reference via its column in a multidimensional array
  this.row = row; // Stores the tiles reference via its row in a multidimensional array
  
  this.blit = function(x, y) // Added a blit function to avoid bloated commands
  {
    this.image.blit(x, y); // A simple call to the original blit command
  }
}
// NOTE: We couldnt support multiple tilesizes while allowing access to all tilesets. The only potential way would be to limit the list of available
// Tilesets to only those with a tileset matching the specified. EG if you specify 32x32 for a map then only the tilesets of those size would be available
// Either way the tilesizes would have to be stored in the induvidual map for reference and in the tileset to compare

//========================================================================================================================
//                                                     Tileset Object
//========================================================================================================================
function tilesetObject(name) // A tileset Object
{
  this.name = name; // Stores the name of the tileset image
  this.surface = LoadImage("~/Tilesets/" + name).createSurface(); // Stores a surface copy of the tilesets image
  this.tileHeight = 32; // This would need to be found somehow
  this.tileWidth = 32; // This would need to be found somehow
  this.image = LoadImage("~/Tilesets/" + name); // Stores a image copy of the tilesets image
  this.width = this.image.width / this.tileWidth; // Stores the amount of tiles via width of the image
  this.height = this.image.height / this.tileHeight; // Stores the amount of tiles via height of the image
  this.numTiles = this.height * this.width; // Gets the overall number of tiles
  this.tile = []; // Array containing the induviadual tiles broken down from the original image
  for (var y = 0; y < this.height; y++)
  {
    for (var x = 0; x < this.width; x++)
    {
      // Creates a new TILEOBJECT of the tile
      this.tile[this.tile.length] = new tileObject(this.surface.cloneSection(x * 32, y * 32, 32, 32), this.tile.length, x, y);
    }
  }
}

// NOTE: Two ways to detect passibility strike me, either create a huge image of the map in black and white to detect collision or induvidually
// Store passibility in each tile. The latter would be slower due to induvidual checks, Okay for tilebased movement I suppose as the checks will only be
// done before moving, pixel movement would require lots of checks

function mapObject(map)
{
  this.name = map;
  var map2 = OpenFile("~/Maps/" + map);
  this.height = map2.read("height", 50);
  this.width = map2.read("width", 50);
  this.layers = map2.read("layers", 2);
  this.tileset = map2.read("tileset", 0);
  this.tiles = [];
  for (var l = 0; l < this.layers; l++)
  {
    this.tiles[l] = [];
    for (var y = 0; y < this.height; y++)
    {
      this.tiles[l][y] = [];
      for (var x = 0; x < this.width; x++)
      {
        this.tiles[l][y][x] = 
        {
          tile: map2.read("tiles[" + l + "][" + y + "][" + x + "].tile", 0),
          tileset: map2.read("tiles[" + l + "][" + y + "][" + x + "].tileset", 0)
        }
      }
    }
  }
  this.layerProps = [];
  for (var i = 0; i < this.layers; i++)
  {
    this.layerProps[i] = { visible: true };
  }
  map2.close();
}

mapObject.prototype.addBlankLayer = function(i)
{
  this.tiles[this.tiles.length] = [];
  for (var y = 0; y < this.height; y++)
  {
    this.tiles[this.tiles.length-1][y] = [];
    for (var x = 0; x < this.width; x++)
    {
      this.tiles[this.tiles.length-1][y][x] = 
      {
        tile: 0,
        tileset: 0
      }
    }
  }
  for (var l = i; l < this.tiles.length-1; l++)
  {
    this.tiles[l].push();
  }
}

mapObject.prototype.shiftTileset = function(layer1, layer2)
{
  for (var l = 0; l < this.layers; l++)
  {
    for (var y = 0; y < this.height; y++)
    {
      for (var x = 0; x < this.width; x++)
      {
        if (this.tiles[l][y][x].tileset == layer1)  
        {
          this.tiles[l][y][x].tileset = layer2; 
          continue;
        }
        if (this.tiles[l][y][x].tileset == layer2)  
        {
          this.tiles[l][y][x].tileset = layer1; 
          continue;
        }
      }
    }
  }
  this.saveTilesetsOnly();
}

mapObject.prototype.saveTilesetsOnly = function()
{
  var map2 = OpenFile("~/Maps/" + this.name);
  for (var l = 0; l < this.layers; l++)
  {
    for (var y = 0; y < this.height; y++)
    {
      for (var x = 0; x < this.width; x++)
      {
        map2.write("tiles[" + l + "][" + y + "][" + x + "].tileset", this.tiles[l][y][x].tileset);
      }
    }
  }
  map2.flush();
  map2.close();
}

mapObject.prototype.save = function()
{
  var map2 = OpenFile("~/Maps/" + this.name);
  map2.write("height", this.height);
  map2.write("width", this.width);
  map2.write("layers", this.layers);
  map2.write("tileset", this.tileset);
  for (var l = 0; l < this.layers; l++)
  {
    for (var y = 0; y < this.height; y++)
    {
      for (var x = 0; x < this.width; x++)
      {
        map2.write("tiles[" + l + "][" + y + "][" + x + "].tile", this.tiles[l][y][x].tile);
        map2.write("tiles[" + l + "][" + y + "][" + x + "].tileset", this.tiles[l][y][x].tileset);
      }
    }
  }
  map2.flush();
  map2.close();
}

var map = new mapObject("Test.nmp");

var tileset = []; // Keep tilesets in the global scope so all panels could reference it if required

var files = GetFileList("~/Tilesets"); // Get list of files in the tilesets folder

var tilesetData = OpenFile("~/Other/Tileset Data.nts");
for (var f = 0; f < tilesetData.read("length", 0); f++)
{
  for (var i = 0; i < files.length; i++)
  {
    if (tilesetData.read("tileset[" + f + "]", "") == files[i]) 
    {
      tileset[tileset.length] = new tilesetObject(files[i]);
      files.splice(i, 1);
    }
  }
}
for (var i = 0; i < files.length; i++) tileset[tileset.length] = new tilesetObject(files[i]);
for (var i = 0; i < tileset.length; i++) tilesetData.write("tileset[" + i + "]", tileset[i].name);
tilesetData.write("length", tileset.length);
tilesetData.close();
files = undefined; // Probably not neccesary but but what the hell 

function saveTilesetData(array)
{
  var tilesetData = OpenFile("~/Other/Tileset Data.nts");
  for (var i = 0; i < tileset.length; i++)
  {
    tilesetData.write("tileset[" + i + "]", tileset[i].name);
  }
  tilesetData.flush();
  tilesetData.close();
}

//========================================================================================================================
//                                                     Drop Box
//========================================================================================================================
function dropBox(parent, fileList)
{
  this.name = "Drop Box";
  this.open = false;
  this.swap = -1;
  this.parent = parent;
  this.x = this.parent.x;
  this.y = this.parent.y + 2 + 24;
  this.h = this.parent.h - 26;
  this.topHeight = 20;
  this.w = this.parent.w;
  this.fileList = fileList;
  this.currentSelection = 0;
  this.innerSelection = 0;
  
  this.vScroll = 0; // Set current posision on scroll vertical
  this.hScroll = 0; // Set current position on scroll horizontal
  this.hInt = 16; // Set width of columns - default to 1
  this.vInt = 16; // Set height of rows - default to 1
  this.vMax = ((tileset.length * 16) - this.h - 26) / this.vInt; // Subtracting the current page get remainder for scrolling purposes
  //this.hMax = (tileset[tilesetSelection].image.width - this.w) / this.hInt; // Subtracting the current page get remainder for scrolling purposes
  
  this.scrollBar = new verticalScrollBar(this); // Create scrollbar
  
  this.window = createWindow (this.parent.w, this.parent.h - 26, true);
  this.image = createWindow(parent.w - 4, 20).createSurface();

  this.image.line(2, 2, this.image.width - 4, 2, CreateColor(128, 128, 128, 255));
  this.image.line(2, 2, 2, this.image.height - 4, CreateColor(128, 128, 128, 255));

  this.image.line(2, this.image.height - 3, this.image.width - 3, this.image.height - 3, CreateColor(255, 255, 255, 255));
  this.image.line(this.image.width - 3, 2, this.image.width - 3, this.image.height - 3, CreateColor(255, 255, 255, 255));

  this.image.line(3, 3, this.image.width - 5, 3, CreateColor(0, 0, 0, 255));
  this.image.line(3, 3, 3, this.image.height - 5, CreateColor(0, 0, 0, 255));

  this.image.line(3, this.image.height - 4, this.image.width - 4, this.image.height - 4, CreateColor(192, 192, 192, 255));
  this.image.line(this.image.width - 4, 3, this.image.width - 4, this.image.height - 4, CreateColor(192, 192, 192, 255));

  this.image.createImage();
  
  this.scrollDown = new _button(this, this.w - 18, -20, scrollDown);
  this.scrollDown.name = "Scroll Down";
  this.scrollDown.leftOnPress = function()
  {
    this.parent.open = !this.parent.open;
  }
}

dropBox.prototype.handleMouse = function()
{
  if (this.open) 
  {
    mouse.isMouseOver(this.parent.x + 2, this.parent.y + 2, this.w, this.h, this);
    this.scrollBar.handleMouse();
  }
  else mouse.isMouseOver(this.parent.x + 2, this.parent.y + 2, this.w, 24, this)
}

dropBox.prototype.render = function()
{
  this.image.blit(this.parent.x + 2, this.parent.y + 2);
  this.scrollDown.render();
  drawText(this.parent.x + 12, this.parent.y + 12, this.fileList[this.currentSelection].name);
  drawText(this.parent.x, this.parent.y - 20, this.swap)
  if (this.open)
  {
    var index = Math.floor((GetMouseY() - this.y) / 16);
    this.window.blit(this.x - 2 + 2, this.y);
    
    for (var i = 0; i < this.fileList.length; i++)
    {
      if (this.swap == i) drawText(this.parent.x + 12, this.parent.y + 32 + (16 * i), this.fileList[i].name, yellow);
      else if (this.currentSelection == i) 
      {
        drawText(this.parent.x + 12, this.parent.y + 32 + (16 * i), this.fileList[i].name, red);
      }
      else drawText(this.parent.x + 12, this.parent.y + 32 + (16 * i), this.fileList[i].name); 
      if (map.layerProps[i] && map.layerProps[i].visible) layerVisible.blit(this.parent.x + this.w - 80, this.parent.y + 28 + (i * 16));
      else layerInvisible.blit(this.parent.x + this.w - 80, this.parent.y + 28 + (i * 16));
      scrollUp.blit(this.parent.x + this.w - 64, this.parent.y + 28 + (i * 16));
      scrollDown.blit(this.parent.x + this.w - 48, this.parent.y + 28 + (i * 16));
      deleteIcon.blit(this.parent.x + this.w - 32, this.parent.y + 28 + (i * 16));
      
    }
    if (index > -1 && index < 12 && index < this.fileList.length) 
    {
      Rectangle(this.x - 2, this.y + 2 + (index * 16), this.parent.w, 16, CreateColor(192, 192, 192, 120));
      if (mouse.x > this.x && mouse.x < this.x + this.w - 80)
      {
        this.innerSelection = -1;
        OutlinedRectangle(this.x - 2, this.y + 2 + (index * 16), this.parent.w - 80, 16, yellow);
      }
      else if (mouse.x > this.parent.x + this.w - 80 && mouse.x < this.parent.x + this.w - 64) 
      {
        this.innerSelection = 0;
        OutlinedRectangle(this.parent.x + this.w - 80, this.parent.y + 28 + (16 * index), 16, 16, yellow);
      }
      else if (mouse.x > this.parent.x + this.w - 64 && mouse.x < this.parent.x + this.w - 48) 
      {
        this.innerSelection = 1;
        OutlinedRectangle(this.parent.x + this.w - 64, this.parent.y + 28 + (16 * index), 16, 16, yellow);
      }
      else if (mouse.x > this.parent.x + this.w - 48 && mouse.x < this.parent.x + this.w - 32) 
      {
        this.innerSelection = 2;
        OutlinedRectangle(this.parent.x + this.w - 48, this.parent.y + 28 + (16 * index), 16, 16, yellow);
      }
      else if (mouse.x > this.parent.x + this.w - 32 && mouse.x < this.parent.x + this.w - 16) 
      {
        this.innerSelection = 3;
        OutlinedRectangle(this.parent.x + this.w - 32, this.parent.y + 28 + (16 * index), 16, 16, yellow);
      }
    }
    this.scrollBar.render();
  }
}

//========================================================================================================================
//                                                     Map Panel
//========================================================================================================================
function _mapPanel()
{
  this.name = "MapPanel"; // Objects name (Not needed, just used in mouse object while testing)
  this.x = 216; // Set panels X
  this.y = 20; // Set panels Y
  this.w = 420; // Set panels W
  this.h = 456; // Set Panels H
  this.window = createWindow(this.w, this.h, true); // Create a window image
  var testWidth = 16 + (Math.floor((this.w - 16) / 32) * 32);
  var testHeight = 16 + (Math.floor((this.h - 64) / 32) * 32);
  this.container = new _mapContainer(this, (this.w - testWidth) / 2, this.y + this.h - testHeight - 26, testWidth, testHeight, 32, 32);
  this.dropBox = new dropBox(this, []); // Create DropBox
  for (var i = 0; i < map.layers; i++)
  {
    this.dropBox.fileList.push({ name: "Layer " + i });
  }
  this.dropBox.leftOnPress = function()
  {
    if (mouse.isMouseOver(this.parent.x + 2, this.parent.y + 2, this.w, 24))
    {
      return this.open = !this.open;
    }
    else
    {
      var index = Math.floor((GetMouseY() - this.y) / 16);
      switch (this.innerSelection)
      {
        case -1:
        {
          if (index > -1 && index < 12 && index < this.fileList.length) 
          {
            this.currentSelection = index;
            layerSelection = index; 
          }
          return;
        }
        case 0:
        {
          return map.layerProps[index].visible = !map.layerProps[index].visible;
        }
        case 1:
        {
          if (this.fileList[index + this.vScroll - 1])
          {
            var swap1 = this.fileList[index + this.vScroll];
            var swap2 = this.fileList[index + this.vScroll - 1]
            this.fileList[index + this.vScroll - 1] = swap1;
            this.fileList[index + this.vScroll] = swap2;
          }
          return;
        }
        case 2:
        {
          if (this.fileList[index + this.vScroll + 1])
          {
            var swap1 = this.fileList[index + this.vScroll];
            var swap2 = this.fileList[index + this.vScroll + 1]
            this.fileList[index + this.vScroll + 1] = swap1;
            this.fileList[index + this.vScroll] = swap2;
          }
          return;
        }
        case 3:
        {
          if (this.fileList.length > 1 && index < this.fileList.length && areYouSure("Delete " + this.fileList[index].name))
          {
            if (layerSelection == index)
            {
              if (layerSelection > 0) { layerSelection--; this.layerSelection--; }
            }
            map.tiles.splice(index, 1);
            map.layers--;
            this.fileList.splice(index, 1);
          }
        }
      }
    }
  }
  this.dropBox.rightOnPress = function()
  {
    var index = Math.floor((GetMouseY() - this.y) / 16);
    var index = Math.floor((GetMouseY() - this.y) / 16);
    if (index > -1 && index < 12 && index < this.fileList.length) 
    {
      this.fileList.push({ name: "Layer " + map.layers })
      map.layers += 1;
      map.addBlankLayer(index);
    }
  }
  this.saveButton = new _button(this, 10, 30, saveIcon, saveIcon);
  this.saveButton.leftOnPress = function()
  {
    switch(choiceBox('Save all changes to "' + map.name + '"?', ['Yes', 'No']))
    {
      case 0: map.save();
    }
  }
}

_mapPanel.prototype.handleMouse = function()
{
  mouse.isMouseOver(this.x, this.y, this.w, this.h, this);
  this.saveButton.handleMouse();
}

_mapPanel.prototype.update = function()
{
  if (mouse.isMouseOver(this.x, this.y, this.w, this.h))
  {
    this.handleMouse();
    this.container.handleMouse();
    this.dropBox.handleMouse();
  }
}

_mapPanel.prototype.render = function()
{
  this.window.blit(this.x, this.y);
  this.container.render();
  this.saveButton.render();
  this.dropBox.render();
}

function _mapContainer(parent, x, y, w, h, hInt, vInt)
{
  this.name = "Map Container";
  this.parent = parent;
  this.x = this.parent.x + x;
  this.y = this.parent.y + y;
  this.w = w;
  this.h = h;
  this.tileW = Math.floor((this.w) / 32);
  this.tileH = Math.floor((this.h) / 32);
  
  this.pageWidth = Math.floor((this.w - 16) / 32); // Get amount of tiles within width
  this.pageHeight = Math.floor((this.h - 16) / 32); // Get amount of tiles within height
  
  this.vScroll = 0; // Set current posision on scroll vertical
  this.hScroll = 0; // Set current position on scroll horizontal
  this.hInt = hInt || 1; // Set width of columns - default to 1
  this.vInt = vInt || 1; // Set height of rows - default to 1
  this.vMax = map.height - this.pageHeight; // Subtracting the current page get remainder for scrolling purposes
  this.hMax = map.width - this.pageWidth; // Subtracting the current page get remainder for scrolling purposes
  
  this.vScrollBar = new verticalScrollBar(this, true); // Create scrollbar
  this.hScrollBar = new horizontalScrollBar(this, true); // Create scrollbar
  this.wheelScrollUp = function() // Refer to scroll bar for wheel functions
  {
    if (this.vScrollBar && this.vScrollBar.wheelScrollUp) this.vScrollBar.wheelScrollUp(); // If scrollbar has a wheel function run that
  }
  this.wheelScrollDown = function() // Create scrollbar
  {
    if (this.vScrollBar && this.vScrollBar.wheelScrollDown) this.vScrollBar.wheelScrollDown(); // If scrollbar has a wheel function run that
  }
  
  this.window = createWindow(this.w, this.h);
  
}

_mapContainer.prototype.handleMouse = function()
{
  if (mouse.isMouseOver(this.x, this.y, this.w, this.h, this)) this.vScrollBar.handleMouse(); this.hScrollBar.handleMouse();
}

_mapContainer.prototype.leftOnPress = function()
{
  var mouseX = Math.floor((mouse.x - this.x - 2) / 32) + this.hScroll; // Get tile co-ords
  var mouseY = Math.floor((mouse.y - this.y - 2) / 32) + this.vScroll; // Get tile co-ords
  if (mouseY >= 0 && mouseX >= 0 && mouseY < map.height && mouseX < map.width) map.tiles[layerSelection][mouseY][mouseX].tile = tileSelection;
  if (mouseY >= 0 && mouseX >= 0 && mouseY < map.height && mouseX < map.width) map.tiles[layerSelection][mouseY][mouseX].tileset = tilesetSelection;
}

_mapContainer.prototype.leftOnHeld = function()
{
  var mouseX = Math.floor((mouse.x - this.x - 2) / 32) + this.hScroll; // Get tile co-ords
  var mouseY = Math.floor((mouse.y - this.y - 2) / 32) + this.vScroll; // Get tile co-ords
  if (mouseY >= 0 && mouseX >= 0 && mouseY < map.height && mouseX < map.width) map.tiles[layerSelection][mouseY][mouseX].tile = tileSelection;
  if (mouseY >= 0 && mouseX >= 0 && mouseY < map.height && mouseX < map.width) map.tiles[layerSelection][mouseY][mouseX].tileset = tilesetSelection;
}

_mapContainer.prototype.render = function()
{
  drawText(200, 0, map.tiles[0][0][0].tile)
  drawText(200, 10, map.tiles[0][0][0].tileset)
  var mouseX = Math.floor((mouse.x - this.x - 2) / 32); // Get tile co-ords
  var mouseY = Math.floor((mouse.y - this.y - 2) / 32); // Get tile co-ords
  this.window.blit(this.x, this.y); 
  SetClippingRectangle(this.x + 2, this.y + 2, this.w, this.h);
  if (mouse.isMouseOver(this.x + 2, this.y + 2, this.w, this.h)) // If mouse is over container
  {
    var mouseX = Math.floor((mouse.x - this.x - 2) / 32); // Get tile co-ords
    var mouseY = Math.floor((mouse.y - this.y - 2) / 32); // Get tile co-ords
  } 
  for (var l = 0; l < map.layers; l++)
  {
    if (map.layerProps[l].visible)
    {
      for (var y = 0; y < this.tileH; y++)
      {
        for (var x = 0; x < this.tileW; x++)
        {
          // Draw tiles
          var tile = map.tiles[l][y + this.vScroll][x + this.hScroll];
          if(tile != undefined) tileset[tile.tileset].tile[tile.tile].blit(this.x + 2 + (x * 32), this.y + 2 + (y * 32));
          if (x == mouseX && mouseY == y) tile32.blit(this.x + 2 + (x * 32), this.y + 2 + (y * 32));
        }
      }
    }
  }
  for (var i = 0; i < 13; i++)
  {
    Line(this.x + 1 + (i * 32), this.y, this.x + 1 + (i * 32), this.y + this.h, black);
    Line(this.x, this.y + 1 + (i * 32), this.x + this.h, this.y + 1 + (i * 32), black);
  }
  
  this.hScrollBar.render();
  this.vScrollBar.render()
  SetClippingRectangle(0, 0, 640, 480);
  //drawText(0, 0, map.tiles[0][0][0]);
  drawText(100, 0, tileSelection);
  drawText(100, 10, tilesetSelection);
}


//========================================================================================================================
//                                                     Tile Panel
//========================================================================================================================

var tilesetSelection = 0; // Store current tileset in the global scope
var tileSelection = 0; // Store selected tile in the global scope
var layerSelection = 0;

function _tilePanel()
{
  this.name = "TilePanel"; // Objects name (Not needed, just used in mouse object while testing)
  this.x = 0; // Set panels X
  this.y = 20; // Set panels Y
  this.w = 212; // Set panels W
  this.h = 220; // Set Panels H
  this.window = createWindow(this.w, this.h, true); // Create a window image
  this.dropBox = new dropBox(this, tileset); // Create DropBox - NOT IMPLEMENTED, VISUAL ONLY
  this.dropBox.leftOnPress = function()
  {
    if (mouse.isMouseOver(this.parent.x + 2, this.parent.y + 2, this.w, 24))
    {
      return this.open = !this.open;
    }
    else
    {
      var index = Math.floor((GetMouseY() - this.y) / 16);
      switch (this.innerSelection)
      {
        case -1:
        {
          if (index > -1 && index < 12 && index < tileset.length) 
          {
            this.currentSelection = index;
            tilesetSelection = index;
            this.parent.container.newScroll(32, 32);  
          }
          return;
        }
        case 0:
        {
          return map.layerProps[index].visible = !map.layerProps[index].visible;
        }
        case 1:
        {
          if (this.fileList[index + this.vScroll - 1])
          {
            map.shiftTileset(index + this.vScroll, index + this.vScroll - 1)
            swap1 = tileset[index + this.vScroll];
            swap2 = tileset[index + this.vScroll - 1];
            tileset[index + this.vScroll] = swap2;
            tileset[index + this.vScroll - 1] = swap1;
            if (tilesetSelection == index + this.vScroll - 1) 
            {
              this.currentSelection = index + this.vScroll;
              tilesetSelection = index + this.vScroll;
              return;
            }
            if (tilesetSelection == index + this.vScroll) 
            {
              this.currentSelection = index + this.vScroll - 1;
              tilesetSelection = index + this.vScroll - 1;
              return;
            }
          }
          return;
        }
        case 2:
        {
          if (this.fileList[index + this.vScroll + 1])
          {
            map.shiftTileset(index + this.vScroll, index + this.vScroll + 1)
            swap1 = tileset[index + this.vScroll];
            swap2 = tileset[index + this.vScroll + 1];
            tileset[index + this.vScroll] = swap2;
            tileset[index + this.vScroll + 1] = swap1;
            if (tilesetSelection == index + this.vScroll + 1) 
            {
              this.currentSelection = index + this.vScroll;
              tilesetSelection = index + this.vScroll;
              return;
            }
            if (tilesetSelection == index + this.vScroll) 
            {
              this.currentSelection = index + this.vScroll + 1;
              tilesetSelection = index + this.vScroll + 1;
              return;
            }
          }
          return;
        }
        case 3:
        {
          if (this.fileList.length > 1 && areYouSure("Delete " + this.fileList[index].name))
          {
            if (tilesetSelection == index)
            {
              if (tilesetSelection > 0) { tilesetSelection--; this.currentSelection--; }
            }
            //tileset.splice(index, 1);
            this.fileList.splice(index, 1);
          }
          return;
        } 
      }
    }
  }
  this.container = new tilesetContainer(this, 2, 26, 208, 192, 32, 32); // Create a container within the panal, will be storing in arrays later
}

//========================================================================================================================
//                                                     Tile Panel - Handle Mouse
//========================================================================================================================
_tilePanel.prototype.handleMouse = function()
{
  mouse.isMouseOver(this.x, this.y, this.w, this.h, this)
}
//========================================================================================================================
//                                                     Tile Panel - Render
//========================================================================================================================
_tilePanel.prototype.update = function()
{
  this.handleMouse();
  this.container.handleMouse();
  this.dropBox.handleMouse();
}

_tilePanel.prototype.render = function()
{
  //SetClippingRectangle(this.x, this.y, this.w + 4, this.h + 4) // Dont allow drawing outside of panel
  this.window.blit(this.x, this.y); // Draw window
  this.container.render(); // Draw container - In future will need top be array and loop
  this.dropBox.render(); // Draw drop box
  //SetClippingRectangle(0, 0, 640, 480); // Reset scope for drawing
}

//========================================================================================================================
//                                                     Tileset Container
//========================================================================================================================
function tilesetContainer(parent, x, y, w, h, hInt, vInt)
{
  this.name = "Tileset Container"; // Objects name (Not needed, just used in mouse object while testing)
  this.parent = parent; // Get Objects Parent
  this.window = createWindow(w, h); // Create window
  this.x = this.parent.x + x; // Set containers X
  this.y = this.parent.y + y; // Set containers Y
  this.h = h; // Set containers H
  this.w = w; // Set containers W
  this.pageWidth = Math.floor(this.w / 32); // Get amount of tiles within width
  this.pageHeight = Math.floor(this.h / 32); // Get amount of tiles within height
  
  this.vScroll = 0; // Set current posision on scroll vertical
  this.hScroll = 0; // Set current position on scroll horizontal
  this.hInt = hInt || 1; // Set width of columns - default to 1
  this.vInt = vInt || 1; // Set height of rows - default to 1
  this.vMax = (tileset[tilesetSelection].image.height - h) / this.vInt; // Subtracting the current page get remainder for scrolling purposes
  this.hMax = (tileset[tilesetSelection].image.width - w) / this.hInt; // Subtracting the current page get remainder for scrolling purposes
  
  this.scrollBar = new verticalScrollBar(this); // Create scrollbar
  this.wheelScrollUp = function() // Refer to scroll bar for wheel functions
  {
    if (this.scrollBar && this.scrollBar.wheelScrollUp) this.scrollBar.wheelScrollUp(); // If scrollbar has a wheel function run that
  }
  this.wheelScrollDown = function() // Create scrollbar
  {
    if (this.scrollBar && this.scrollBar.wheelScrollDown) this.scrollBar.wheelScrollDown(); // If scrollbar has a wheel function run that
  }
}

tilesetContainer.prototype.newScroll = function(hInt, vInt)
{
  this.vScroll = 0; // Set current posision on scroll vertical
  this.hScroll = 0; // Set current position on scroll horizontal
  this.hInt = hInt; // Set width of columns - default to 1
  this.vInt = vInt; // Set height of rows - default to 1
  this.vMax = (tileset[tilesetSelection].image.height - this.h) / this.vInt; // Subtracting the current page get remainder for scrolling purposes
  if (this.vMax < 0) this.vMax = 0;
  this.hMax = (tileset[tilesetSelection].image.width - this.w) / this.hInt; // Subtracting the current page get remainder for scrolling purposes
  
  this.scrollBar = new verticalScrollBar(this); // Create scrollbar
}
//========================================================================================================================
//                                                     Tileset Container - Handle Mouse
//========================================================================================================================
tilesetContainer.prototype.handleMouse = function()
{
  if (mouse.isMouseOver(this.x + 2, this.y + 2, this.w, this.h, this)) this.scrollBar.handleMouse();
  //if (!mouse.isMouseOver(this.x + 2, this.y + 2, this.w - 16, this.h, this)) this.scrollBar.handleMouse(); // If mouse is over containers scrollbar and the button is clicked handle the scrollbars mouse control
}
//========================================================================================================================
//                                                     Tileset Container - Left On Press
//========================================================================================================================
tilesetContainer.prototype.leftOnPress = function()
{
  var mouseX = Math.floor((mouse.x - this.x - 2) / 32); // Get tile co-ords
  var mouseY = Math.floor((mouse.y - this.y - 2) / 32); // Get tile co-ords
  tileSelection = (this.vScroll * 6) + mouseX + (mouseY * 6);
}

//========================================================================================================================
//                                                     Tileset Container - Render
//========================================================================================================================
tilesetContainer.prototype.render = function()
{
  this.window.blit(this.x, this.y); // Draw window
  if (mouse.isMouseOver(this.x + 2, this.y + 2, this.w, this.h)) // If mouse is over container
  {
    var mouseX = Math.floor((mouse.x - this.x - 2) / 32); // Get tile co-ords
    var mouseY = Math.floor((mouse.y - this.y - 2) / 32); // Get tile co-ords
  }
  for (var y = 0; y < 6; y++)
  {
    for (var x = 0; x < 6; x++)
    {
      // Draw tiles
      if(tileset[tilesetSelection].tile[(this.vScroll * 6) + (y * 6) + x]) tileset[tilesetSelection].tile[(this.vScroll * 6) + (y * 6) + x].blit(this.x + 2 + (x * 32), this.y + 2 + (y * 32));
      // If tile selected draw highlight
      if ((this.vScroll * 6) + (y * 6) + x == tileSelection) 
      {
        Rectangle(this.x + 2 + (x * 32), this.y + 2 + (y * 32), 32, 32, CreateColor(255, 0, 255, 100));
        tile32.blit(this.x + 2 + (x * 32), this.y + 2 + (y * 32));
      }
      // If mouse is over draw highlight
      if (x == mouseX && mouseY == y) tile32.blit(this.x + 2 + (x * 32), this.y + 2 + (y * 32));
    }
  }
  this.scrollBar.render(); // Draw Scrollbar
}




function _filePanel()
{
  this.name = "File Panel"; // Objects name (Not needed, just used in mouse object while testing)
  this.x = 0; // Set panels X
  this.y = 242; // Set panels Y
  this.w = 212; // Set panels W
  this.h = 220; // Set Panels H
  this.window = createWindow(this.w, this.h, true); // Create a window image
  this.container = new fileContainer(this, 10, 10, this.w - 20, this.h - 20, 0, 0);
}

_filePanel.prototype.render = function()
{
  this.window.blit(this.x, this.y);
  this.container.render();
  //for (var i = 0; i < this.list.length; i++)
  //{
    //drawText(this.x + 4, this.y + 6 + (i * 16), this.list[i]);
  //}
}

//========================================================================================================================
//                                                     Tileset Container
//========================================================================================================================
function fileContainer(parent, x, y, w, h, hInt, vInt)
{
  this.name = "File Container"; // Objects name (Not needed, just used in mouse object while testing)
  this.parent = parent; // Get Objects Parent
  this.window = createWindow(w, h); // Create window
  this.x = this.parent.x + x; // Set containers X
  this.y = this.parent.y + y; // Set containers Y
  this.h = h; // Set containers H
  this.w = w; // Set containers W

  this.folder = "~/Maps/"
  this.list = this.getFiles("~/Maps/");

  //this.list = GetFileList("~/Maps/");
  this.pageWidth = Math.floor(this.w / 32); // Get amount of tiles within width
  this.pageHeight = Math.floor(this.h / 32); // Get amount of tiles within height
  
  this.vScroll = 0; // Set current posision on scroll vertical
  this.hScroll = 0; // Set current position on scroll horizontal
  this.hInt = hInt || 1; // Set width of columns - default to 1
  this.vInt = vInt || 1; // Set height of rows - default to 1
  this.vMax = (tileset[tilesetSelection].image.height - h) / this.vInt; // Subtracting the current page get remainder for scrolling purposes
  this.hMax = (tileset[tilesetSelection].image.width - w) / this.hInt; // Subtracting the current page get remainder for scrolling purposes
  
  this.scrollBar = new verticalScrollBar(this); // Create scrollbar
  this.wheelScrollUp = function() // Refer to scroll bar for wheel functions
  {
    if (this.scrollBar && this.scrollBar.wheelScrollUp) this.scrollBar.wheelScrollUp(); // If scrollbar has a wheel function run that
  }
  this.wheelScrollDown = function() // Create scrollbar
  {
    if (this.scrollBar && this.scrollBar.wheelScrollDown) this.scrollBar.wheelScrollDown(); // If scrollbar has a wheel function run that
  }
}

fileContainer.prototype.getFiles = function(dir)
{
  var files = GetDirectoryList(dir);
  var directories = [];
  directories[directories.length] = { name:".", type:0 }
  directories[directories.length] = { name:"...", type:0 }
  for (var i = 0; i < files.length; i++) directories[directories.length] = { name: files[i], type: 0 };
  files = GetFileList(dir);
  var newFiles = [];
  for (var i = 0; i < files.length; i++) newFiles[newFiles.length] = { name: files[i], type: 1 }; 
  var list = [];
  for (var i = 0; i < directories.length; i++) list.push(directories[i]);
  for (var i = 0; i < newFiles.length; i++) list.push(newFiles[i]);
  return list
}

fileContainer.prototype.newScroll = function(hInt, vInt)
{
  this.vScroll = 0; // Set current posision on scroll vertical
  this.hScroll = 0; // Set current position on scroll horizontal
  this.hInt = hInt; // Set width of columns - default to 1
  this.vInt = vInt; // Set height of rows - default to 1
  this.vMax = (tileset[tilesetSelection].image.height - this.h) / this.vInt; // Subtracting the current page get remainder for scrolling purposes
  if (this.vMax < 0) this.vMax = 0;
  this.hMax = (tileset[tilesetSelection].image.width - this.w) / this.hInt; // Subtracting the current page get remainder for scrolling purposes
  
  this.scrollBar = new verticalScrollBar(this); // Create scrollbar
}
//========================================================================================================================
//                                                     Tileset Container - Handle Mouse
//========================================================================================================================
fileContainer.prototype.handleMouse = function()
{
  if (mouse.isMouseOver(this.x + 2, this.y + 2, this.w, this.h, this)) this.scrollBar.handleMouse();
  //if (!mouse.isMouseOver(this.x + 2, this.y + 2, this.w - 16, this.h, this)) this.scrollBar.handleMouse(); // If mouse is over containers scrollbar and the button is clicked handle the scrollbars mouse control
}
//========================================================================================================================
//                                                     Tileset Container - Left On Press
//========================================================================================================================
fileContainer.prototype.leftOnPress = function()
{
  //var mouseX = Math.floor((mouse.x - this.x - 2) / 32); // Get tile co-ords
  //var mouseY = Math.floor((mouse.y - this.y - 2) / 32); // Get tile co-ords
  //tileSelection = (this.vScroll * 6) + mouseX + (mouseY * 6);
}

//========================================================================================================================
//                                                     Tileset Container - Render
//========================================================================================================================
fileContainer.prototype.render = function()
{
  var index = Math.floor((GetMouseY() - this.y) / 16);
  if (mouse.x > this.x && mouse.x < this.x + this.w && index > -1 && index < this.list.length) Rectangle(this.x, this.y + (index * 16), this.w - 16, 16, CreateColor(192, 192, 192, 120))
  this.window.blit(this.x, this.y); // Draw window
  for (var i = 0; i < this.h / 16; i++)
  {
    if (this.list[i + this.vScroll]) 
    {
      if (this.list[i].type == 0) directoryIcon.blit(this.x + 4, this.y + (i * 16));
      if (this.list[i].type == 1) mapIcon.blit(this.x + 4, this.y + (i * 16));
      drawText(this.x + 20, this.y + 6 + (i * 16), this.list[i].name);
    }
  }
  this.scrollBar.render(); // Draw Scrollbar
}





function _button(parent, x, y, image, image2)
{
  this.name = "Button";
  this.parent = parent;
  this.x = this.parent.x + x;
  this.y = this.parent.y + y;
  this.w = image.width;
  this.h = image.height;
  this.superParent = getParent(this);
  this.image = image;
  this.pressImage = image2 || image;
  this.w = image.width;
  this.h = image.height
  this.mouseIsOver = function() {}; /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  this.leftOnPress = function () {};
  this.leftOnHeld = function () {};
  this.leftOnRelease = function () {};
  this.rightOnPress = function () {};
  this.rightOnHeld = function () {};
  this.rightOnRelease = function () {};
  this.middleOnPress = function () {};
  this.middleOnHeld = function () {};
  this.middleOnRelease = function () {};
  this.wheelScrollUp = function ()
  {
    if (this.parent instanceof verticalScrollBar && this.parent.wheelScrollDown)
    {
      this.parent.wheelScrollUp();
    }
  }
  this.wheelScrollDown = function ()
  {
    if (this.parent instanceof verticalScrollBar && this.parent.wheelScrollDown)
    {
      this.parent.wheelScrollDown();
    }
  }
  this.addProperty = function (name, arg) { this[name] = arg; };
}

_button.prototype.handleMouse = function()
{
  mouse.isMouseOver(this.x, this.y, this.w, this.h, this);
}

_button.prototype.render = function()
{
  this.image.blit(this.x, this.y);
}

//========================================================================================================================
//                                                     Vertical ScrollBar
//========================================================================================================================
function verticalScrollBar(parent, offset)
{
  this.name = "Vertical Scroll Bar";
  
  this.grabbed = false;
  this.parent = parent;
  this.x = this.parent.x + 2 + this.parent.w - 16;
  this.y = this.parent.y + 2
  this.w = 16;
  this.h = this.parent.h;
  if (offset) this.h -= 16;
  this.timer = GetTime();
  this.lastScroll = 0;
  
  this.leftOnPress = function()
  {
    this.timer = GetTime() + 200;
    var position = Math.floor((mouse.y - (this.y + 18)) / this.middleButton.h); // Work out current position within bar, in relation to the mouse BUG HERE
    if (position > this.parent.vMax) position = this.parent.vMax;
    if (position < 0) position = 0;
    
    if (position < this.parent.vScroll) 
    {
      this.lastScroll = 0;
      this.parent.vScroll--;
    }
    
    if (position > this.parent.vScroll)
    {
      this.lastScroll = 1;
      this.parent.vScroll++;
    }
    return this.updateMiddle();
  }
  this.leftOnHeld = function ()
  {
    if (GetTime() > this.timer + 100)
    {
      this.timer = GetTime();
      var position = Math.floor((mouse.y - (this.y + 18)) / this.middleButton.h); // Work out current position within bar, in relation to the mouse
      if (position > this.parent.vMax) position = this.parent.vMax;
      if (position < 0) position = 0;
      
      if (position > this.parent.vScroll && this.lastScroll)
      {
        this.parent.vScroll++;
      }
      if (position < this.parent.vScroll && !this.lastScroll) 
      {
        this.parent.vScroll--;
      }
    }
    return this.updateMiddle();
  }
  
  this.wheelScrollUp = function()
  {
    if (this.parent.vScroll - 1 >= 0)
    {
      this.parent.vScroll--;
      this.updateMiddle();
    }
  }
  this.parent.wheelScrollUp = this.wheelScrollUp;
  this.wheelScrollDown = function()
  {
    if (this.parent.vScroll + 1 <= this.parent.vMax)
    {
      this.parent.vScroll++;
      this.updateMiddle();
    }
  }
  this.parent.wheelScrollDown = this.wheelScrollDown;
  
  this.superParent = getParent(this);
  var height = Math.floor((this.h - 32) / (this.parent.vMax + 1))
  if (height < 1) height = this.h - 32;
  
  var image = CreateSurface(16, height, CreateColor(195, 195, 195, 255));
  image.line(image.width - 1, 0, image.width - 1, image.height - 1, CreateColor(0, 0, 0, 255));
  image.line(0, image.height - 1, image.width - 1, image.height - 1, CreateColor(0, 0, 0, 255));
  
  image.line(1, 1, image.width - 2, 1, CreateColor(255, 255, 255, 255));
  image.line(1, 1, 1, image.height - 2, CreateColor(255, 255, 255, 255));
      
  image.line(image.width - 2, 1, image.width - 2, image.height - 2, CreateColor(122, 132, 131, 255));
  image.line(2, image.height - 2, image.width - 2, image.height - 2, CreateColor(122, 132, 131, 255));
  
  image.createImage();
  
  this.scrollUp = new _button(this, 0, 0, scrollUp);
  this.scrollUp.name = "Scroll Up";
  this.scrollUp.leftOnPress = function()
  {
    if (this.parent.parent.vScroll - 1 >= 0)
    {
      this.parent.parent.vScroll--;
      this.parent.updateMiddle();
    }
  }
  
  this.middleButton = new _button(this, 0, 16, image);
  this.middleButton.name = "Middle Button";
  this.middleButton.leftOnHeld = function()
  {
    var position = Math.floor((mouse.y - (this.parent.y + 18)) / this.h); // Work out current position within bar, in relation to the mouse BUG HERE
    if (position > this.parent.parent.vMax) position = this.parent.parent.vMax;
    if (position < 0) position = 0;
    if (position <= this.parent.parent.vMax && position >= 0) // If within the confines of the bar
    {
      this.parent.parent.vScroll = position; // Se new position based on earlier calculation
      this.parent.updateMiddle();
    }
  }
  this.scrollDown = new _button(this, 0, this.h - 16, scrollDown);
  this.scrollDown.name = "Scroll Down";
  this.scrollDown.leftOnPress = function()
  {
    if (this.parent.parent.vScroll + 1 <= this.parent.parent.vMax)
    {
      this.parent.parent.vScroll++;
      this.parent.updateMiddle();
    }
  }
  this.updateMiddle = function()
  {
    this.middleButton.y = this.y + 16 + (((this.h - 32 - this.middleButton.h) / this.parent.vMax) * this.parent.vScroll);
  }
}
//========================================================================================================================
//                                                    Vertical Scrollbar - Handle Mouse
//========================================================================================================================
verticalScrollBar.prototype.handleMouse = function()
{
  mouse.isMouseOver(this.x, this.y + 16, 16, this.h - 32, this);
  this.scrollUp.handleMouse();
  this.middleButton.handleMouse();
  this.scrollDown.handleMouse();
}

//========================================================================================================================
//                                                     Vertical Scrollbar - Handle Button
//========================================================================================================================
verticalScrollBar.prototype.handleButton = function(integ)
{
  // Handle the button controls
  switch (integ)
  {
    case 0:
    {
      // Handle Up button
      if (this.parent.vScroll > 0) this.parent.vScroll--; // Scroll Up
      break;
    }
    case 1:
    {
      // Handle Down button
      if (this.parent.vScroll < this.parent.vMax) this.parent.vScroll++; // Scroll Down
      break;
    }
  }
}

//========================================================================================================================
//                                                     Vertial ScrollBar - Render
//========================================================================================================================
verticalScrollBar.prototype.render = function()
{
  Rectangle(this.parent.x + this.parent.w - 14, this.y, 16, this.h, windowGrey3); // Scrollbar background - MAY BE BETTER AS IMAGE
  this.scrollUp.render();
  this.middleButton.render();
  this.scrollDown.render();
}

//========================================================================================================================
//                                                     Horizontal ScrollBar
//========================================================================================================================
function horizontalScrollBar(parent, offset)
{
  this.name = "Horizontal Scroll Bar";
  
  this.grabbed = false;
  this.parent = parent;
  this.x = this.parent.x + 2;
  this.y = this.parent.y + 2 + this.parent.h - 16
  this.w = this.parent.w;
  this.h = 16;
  if (offset) this.w -= 16;
  this.timer = GetTime();
  //this.lastScroll = 0;
  
  this.leftOnPress = function()
  {
    this.timer = GetTime() + 200;
    var position = Math.floor((mouse.x - (this.x + 18)) / this.middleButton.w); // Work out current position within bar, in relation to the mouse
    if (position > this.parent.hMax) position = this.parent.hMax;
    if (position < 0) position = 0;
    
    if (position < this.parent.hScroll) 
    {
      this.lastScroll = 0;
      this.parent.hScroll--;
    }
    
    if (position > this.parent.hScroll)
    {
      this.lastScroll = 1;
      this.parent.hScroll++;
    }
    return this.updateMiddle();
  }
    
  this.leftOnHeld = function ()
  {
    if (GetTime() > this.timer + 100)
    {
      this.timer = GetTime();
      var position = Math.floor((mouse.x - (this.x + 18)) / this.middleButton.w); // Work out current position within bar, in relation to the mouse
      if (position > this.parent.hMax) position = this.parent.hMax;
      if (position < 0) position = 0;
      
      if (position > this.parent.hScroll && this.lastScroll)
      {
        this.parent.hScroll++;
      }
      if (position < this.parent.hScroll && !this.lastScroll) 
      {
        this.parent.hScroll--;
      }
    }
    return this.updateMiddle();
  }
  
  this.superParent = getParent(this);
  var width = Math.floor((this.w - 32) / (this.parent.hMax + 1))
  if (width < 1) width = this.w - 32;
  
  var image = CreateSurface(width, 16, CreateColor(195, 195, 195, 255));
  image.line(image.width - 1, 0, image.width - 1, image.height - 1, CreateColor(0, 0, 0, 255));
  image.line(0, image.height - 1, image.width - 1, image.height - 1, CreateColor(0, 0, 0, 255));
  
  image.line(1, 1, image.width - 2, 1, CreateColor(255, 255, 255, 255));
  image.line(1, 1, 1, image.height - 2, CreateColor(255, 255, 255, 255));
      
  image.line(image.width - 2, 1, image.width - 2, image.height - 2, CreateColor(122, 132, 131, 255));
  image.line(2, image.height - 2, image.width - 2, image.height - 2, CreateColor(122, 132, 131, 255));
  
  image.createImage();
  
  this.scrollLeft = new _button(this, 0, 0, scrollLeft);
  this.scrollLeft.name = "Scroll Up";
  this.scrollLeft.leftOnPress = function()
  {
    if (this.parent.parent.hScroll - 1 >= 0)
    {
      this.parent.parent.hScroll--;
      this.parent.updateMiddle();
    }
  }
  
  this.middleButton = new _button(this, 16, 0, image);
  this.middleButton.name = "Middle Button";
  this.middleButton.leftOnHeld = function()
  {
    var position = Math.floor((mouse.x - (this.parent.x + 18)) / this.w); // Work out current position within bar, in relation to the mouse
    if (position > this.parent.parent.hMax) position = this.parent.parent.hMax;
    if (position < 0) position = 0;
    if (position <= this.parent.parent.hMax && position >= 0) // If within the confines of the bar
    {
      this.parent.parent.hScroll = position; // Se new position based on earlier calculation
      this.parent.updateMiddle();
    }
  }
  this.scrollRight = new _button(this, this.w - 16, 0, scrollRight);
  this.scrollRight.name = "Scroll Right";
  this.scrollRight.leftOnPress = function()
  {
    if (this.parent.parent.hScroll + 1 <= this.parent.parent.hMax)
    {
      this.parent.parent.hScroll++;
      this.parent.updateMiddle();
    }
  }
  this.updateMiddle = function()
  {
    this.middleButton.x = this.x + 16 + (((this.w - 32 - this.middleButton.w) / this.parent.hMax) * this.parent.hScroll);
  }
}
//========================================================================================================================
//                                                    Vertical Scrollbar - Handle Mouse
//========================================================================================================================
horizontalScrollBar.prototype.handleMouse = function()
{
  mouse.isMouseOver(this.x + 16, this.y, this.w - 32, 16, this);
  this.scrollLeft.handleMouse();
  this.middleButton.handleMouse();
  this.scrollRight.handleMouse();
}

//========================================================================================================================
//                                                     Vertical Scrollbar - Handle Button
//========================================================================================================================++++++++++++++++++++++++++++++++++++++++++++
horizontalScrollBar.prototype.handleButton = function(integ)
{
  // Handle the button controls
  switch (integ)
  {
    case 0:
    {
      // Handle Up button
      if (this.parent.hScroll > 0) this.parent.hScroll--; // Scroll Up
      break;
    }
    case 1:
    {
      // Handle Down button
      if (this.parent.hScroll < this.parent.hMax) this.parent.hScroll++; // Scroll Down
      break;
    }
  }
}

//========================================================================================================================
//                                                     Vertial ScrollBar - Render
//========================================================================================================================
horizontalScrollBar.prototype.render = function()
{
  Rectangle(this.x, this.y, this.w, 16, windowGrey3); // Scrollbar background - MAY BE BETTER AS IMAGE
  this.scrollLeft.render();
  this.middleButton.render();
  this.scrollRight.render();
}



//========================================================================================================================
//                                                     Game Functions
//========================================================================================================================

var tilePanel = new _tilePanel(); // Create the tile panel
var mapPanel = new _mapPanel();
var filePanel = new _filePanel();
var frameRate = 60; // Set the frame rate

var exit = new _button(global, 624, 0, xIcon, xIcon);
exit.leftOnPress = function()
{ 
  switch(choiceBox('Are you sure you want to quit?', ['Yes', 'No']))
  {
    case 0:
    {
      switch(choiceBox('Save all changes to "' + map.name + '"?', ['Yes', 'No', 'Cancel']))
      {
        case 0: map.save();
        case 1:
        saveTilesetData();
        Exit();
        case 2: return;
      }
    }
  }
}

function _frameEngine()
{
  this.CPS = 0;
  this.FPS = 0;
  this.CPSTimer = GetTime();
  this.FPSTimer = GetTime();
  this.currentCPS = 0;
  this.currentFPS = 0;
  this.frame = 0;
  this.time = GetTime();

  this.update = function() {};
  this.render = function() {};

  this.execute = function()
  {
    while (this)
    {
      //this.update();
      this.time = GetTime();
      if (this.time > this.CPSTimer + 1000)
      {
        this.currentCPS = this.CPS + 1;
        this.currentFPS = this.FPS + 1;
        this.CPS = 0;
        this.FPS = 0;
        this.CPSTimer = this.time;
        this.FPSTimer = this.time;
      }
      else
      {  
        this.CPS++;
        if (this.time > this.FPSTimer + (1000 / frameRate))
        {
          this.FPS++;
          this.FPSTimer += (1000 / frameRate);
        }
      }
      if (this.frame != this.FPS)
      {
        this.render();
        this.update();
        this.frame = this.FPS;
        drawText(0, 45, this.FPS);
        drawText(0, 15, this.currentCPS);
        drawText(0, 30, this.currentFPS);
        flipScreen();
      }
      flipped = false;
    }
  }
}
var flipped = false;
function flipScreen()
{
  if (!flipped) FlipScreen();
}

var frameEngine = new _frameEngine();
frameEngine.update = function()
{
  mouse.update();
  mapPanel.update();
  tilePanel.update();
  exit.handleMouse();
}
frameEngine.render = function()
{
  tilePanel.render();
  mapPanel.render();
  filePanel.render();
  exit.render();
  mouse.render();
}











function wrapText(text, w, font)
{
  this.text = [];
  var lastLine = 0;
  var last = 0;
  for (var i = 0; i < text.length; i++)
  {
    if (text.charAt(i) == " " && last != i || i == text.length-1)
    {
      if (font.getStringWidth(text.slice(lastLine, i - lastLine)) > w)
      {        
        this.text[this.text.length] = text.slice(lastLine, last - lastLine);
        lastLine = i;
      }
      else if (i == text.length - 1)
      {
        this.text[this.text.length] = text.slice(lastLine);
      }
      last = i + 1;
    }
  }
}

function choiceBox(text, array)
{
  this.text = font.wordWrapString(text, 300);
  this.w = 300;
  this.x = (GetScreenWidth() - this.w) / 2; 
  this.h = (font.getHeight() * this.text.length) + ((font.getHeight() + 8) * array.length) + 8;
  this.y = (GetScreenHeight() - this.h - 4) / 2;
  this.window = createWindow(this.w, this.h, true);
  this.result = undefined;
  this.mouse = new _mouse();
  this.buttons = [];
  
  for (var i = 0; i < array.length; i++)
  {
    var width = font.getStringWidth(array[i]) + 16;
    if (width < 100) width = 100
    var test = createWindow(width, (font.getHeight() + 4), true).createSurface();
    font.setColorMask(black);
    test.drawText(font, (test.width / 2) - (font.getStringWidth(array[i]) / 2) + 1, 3 + (test.height / 2) - (font.getHeight() / 2), array[i]);
    font.setColorMask(white);
    test.drawText(font, (test.width / 2) - (font.getStringWidth(array[i]) / 2), 2 + ((test.height - font.getHeight()) / 2), array[i]);
    this.buttons[i] = new _button(this, (this.w / 2) - (test.width / 2), 2 + (this.text.length * (font.getHeight() + 4)) + (i * 20), test, test);
    this.buttons[i].i = i;
    this.buttons[i].leftOnPress = function() { this.parent.result = this.i; }
  }
  
  while(this.result == undefined)
  { 
    frameEngine.render();
    this.window.blit(this.x, this.y);
    for (var i = 0; i < this.buttons.length; i++) this.buttons[i].render();
    for (var i = 0; i < this.text.length; i++) drawText(this.x + ((this.w / 2) - (font.getStringWidth(this.text[i]) / 2)), this.y + 4 + (i * font.getHeight()), this.text[i]);
    this.mouse.render();
    flipScreen();
    for (var i = 0; i < this.buttons.length; i++) this.buttons[i].handleMouse();
    this.mouse.update();
  }
  return this.result;
}









function game()
{
  frameEngine.execute();
}